function y = abic_gev(s, param)

mu      = param(1);
sigma   = param(2);
xi      = param(3);
gamma   = param(4);
kappa   = param(5);

shat = mean(s);
J = numel(s);


bic = -2*sum(log(pdfofs_gev(s, param))) + numel(param)*log(J);
y(1) = bic;

aic = -2*sum(log(pdfofs_gev(s, param))) + 2*numel(param);
y(2) = aic;