function y = plotjrofs_galton(s, param)
% myplotjrofs2: on 5/28/14. For some reason myplot fucks things up with
% plot. There is some unknown line added to a pdf and I don't know where it
% came from. It disappears if I switch myplot(i) to monplot(i). I really
% don't know why but I'm using monplot here. 
% plotjrofs3: on 5/31/14. Coloring the cities according to their size.
% plotjrofs4: removing the gray circle perimeter for better visibility. 
% plotjrofs5: switching to pdfofs9 from pdfofs4 for log-scaled s for better
% pdf representation. 
% plotjrofs6 on 6/24/14: switching pdfofs11 (step by step) to pdfofs11
% (smooth, analytical). 
% plotjrof7 on 6/25/14: swithcing the rescaling method for emppdf (i.e.,
% kernel density) to line it up with estpdf from just having the same peak
% height to minimal squared sum of residuals using deflator.m
% plotjrofs_galton on 7/5/14: based on plotjrofs7.m with distribution
% switched to galton from jr. 

% close all
color
s = sort(s); % sort s so that pdf and cdf plots won't go back and forth. 
% Also, remove 0 from s so you can take a log. 

% for i = 1:2
% %     myt(i, :) = num2str(i, '%d');
%     filenames(i, :) = strcat('jrofs_mse', myt(i, :));
% end
filenames(1, :) = 'galton_mse_pdf';
filenames(2, :) = 'galton_mse_cdf';

showfigure = [1 1];

J = numel(s);

if showfigure(1)
    figure(3)
    set(gcf,'defaultaxesfontsize', 13, 'DefaultAxesLineWidth', 1, 'DefaultAxesColorOrder', [gris; rjvb(end, :); .7*noir+.3*blanc], ...
        'defaultlinelinewidth', 2, ...
        'defaultlinemarkersize', 20, ...
        'defaultlinemarker', '.', ...
        'defaulttextfontsize', 13, ...
        'defaultaxesnextplot', 'add', ...
        'units', 'normalized', 'position', [0.65,0.515,0.291666666666667,0.388888888888889;])
                
%         find ks density (equally spaced s) ===========
%             ks density estimation works for standardized data. Since log(s)
%             follows Gaussian, I'll take a log of s first ...
            [emppdf2, si2] = ksdensity(log(s));
%             ... and then convert it back to linear scale 
            si2 = exp(si2);
%         =================================
%     monplot(1) = plot(si2, emppdf2/max(emppdf2)*max(pdfofs11(s, param))); hold all  % draw a line only 
    mydeflator = deflator_galton(ksdensity(log(s), log(s)), s.*lognpdf(s, param(1), param(2)));
%     mydeflator = 1; 
    monplot(1) = plot(si2, emppdf2); hold all
     
%         find ks density (datapoint s) ===========
%             ks density estimation works for standardized data. Since log(s)
%             follows Gaussian, I'll take log of s first ...
            [emppdf, si] = ksdensity(log(s), log(s));  % second log(s) to mark s at which ksdensity is evaluated
%             ... and then convert it back to linear scale 
            si = exp(si);
%         =================================
%     monplot(1) = plot(si, emppdf/max(emppdf)*max(pdfofs4(s, param))); hold all
                % rescale data above so it will match the estimated pdf
                % (pdfofs). These two are evaluated at two differenent sets
                % of s's. Plus, estimated pdf below is the derivative whereas
                % ksdensity above is produced from s. There is no guarantee that
                % they will match up in scale.  
                myemppdf = emppdf;
                %       Assign color according to the city size =============
        for i = 1:J
            if s(i) == 1
                mycolor(i, :) = rjvb(1, :);
            else
                mycolor(i, :) = rjvb(ceil((s(i) - min(s))/(max(s) - min(s))*255), :);
            end  
        end
%         =====================================================
    for i = 1:J
        mycities(i) = plot(si(i), myemppdf(i), 'color', mycolor(i, :)); 
    end
    monplot(2) = plot(si(1), myemppdf(1)); % this is for legend entry only. myplot(1) does dots and myplot(4) does a line. 
    monplot(3) = plot(si, si.*pdfofs_galton_smooth(si, param)/mydeflator); 
%     monplot(3) = plot(s, pdfofs11(s, param));

    set(mycities, 'marker', '.', 'markersize', 15) %, 'line', '-', 'linewidth', .1, 'color', gris)
    set(monplot(1), 'marker', 'none', 'line', '-', 'linewidth', 1, 'color', gris)
    set(monplot(2), 'marker', '.', 'markersize', 15, 'line', '-', 'linewidth', .1, 'color', gris, 'markeredgecolor', rjvb(1, :))  
    set(monplot(3), 'marker', 'none')
    
%     plot city names =====================================================
        showrank = 0;
        myrank = [1 23  27  35  69]';
        myrankstr = num2str(myrank);
        myrank = (J+1)*ones(numel(myrank), 1) - myrank; % actual s is in ascending order. Revert the rank. 
        mycityname = {'Antwerp', 'Genk', 'Mouscron', 'Beringen', 'Arlon'};
        myoffset = 2e-2;
        for i = 1:numel(myrank)
    %         mytext(i) = text(myempcdf(myrank(i)), mycdfofs(myrank(i)), strcat(sprintf('#%s\t', strtrim(myrankstr(i, :))), cellstr(mycityname(i))), 'color', mycolor(myrank(i), :));
            if showrank
                mytext(i) = text(s(myrank(i)) - myoffset, myemppdf(myrank(i)) + myoffset, ...
                sprintf('#%s %s', strtrim(myrankstr(i, :)), char(cellstr(mycityname(i)))), 'color', mycolor(myrank(i), :));
    %         mytextrank(i) = text(emppdf(myrank(i)), mycdfofs(myrank(i)), cellstr(myranknumber(i)), 'color', mycolor(myrank(i), :));
            else
                mytext(i) = text(s(myrank(i)) - myoffset, myemppdf(myrank(i)) + myoffset, ...
                cellstr(mycityname(i)), 'color', mycolor(myrank(i), :)); 
            end
            mydot(i) = plot(s(myrank(i)), myemppdf(myrank(i)), 'markerfacecolor', mycolor(myrank(i), :));
        end
%         set(mytext, 'verticalalignment', 'bottom', 'horizontalalignment', 'left')
        set(mytext, 'verticalalignment', 'middle', 'horizontalalignment', 'right', 'rotation', -90)
        set(mytext(4), 'verticalalignment', 'bottom')
    %     set(mytextrank, 'verticalalignment', 'bottom', 'horizontalalignment', 'right')
        set(mydot, 'marker', 'o', 'markersize', 8, 'markeredgecolor', gris, 'linewidth', 2)
%         =================================================================
    
    mylegend = legend([monplot(2) monplot(3)], 'Data', 'Estimated PDF');
    set(mylegend, 'location', 'best', 'box', 'off')
    xlabel('City Size s')
    ylabel('PDF')
    
        grid on
        set(gca, 'xcolor', grisp, 'ycolor', grisp, 'zcolor', grisp, 'gridlinestyle', '-', 'minorgridlinestyle', '-')
        set(gca, 'xlim', [s(1)-1e-2 s(end)])
        set(gca, 'xscale', 'log')
        set(gca, 'yticklabel', sprintf('%01.2f|', 0:.05:.25))
        Caxes = copyobj(gca,gcf);
        set(Caxes, 'color', 'none', 'xcolor', noir, 'xgrid', 'off', 'ycolor', noir, 'ygrid','off')
end

if showfigure(2)
    figure(4)
    set(gcf,'defaultaxesfontsize', 13, 'DefaultAxesLineWidth', 1, 'DefaultAxesColorOrder', [.7*noir + .3*blanc; vert; bfonce], ...
        'defaultlinelinewidth', 2, ...
        'defaultlinemarkersize', 10, ...
        'defaultlinemarker', '.', ...
        'defaulttextfontsize', 13, ...
        'defaultaxesnextplot', 'add', ...        
        'units', 'normalized', 'position', [0.65    0.04    0.291666666666667,0.388888888888889])
%         'units', 'normalized', 'position', [0.65,0.515,0.291666666666667,0.388888888888889;]) % to the right of fig(1)
%         'units', 'normalized', 'position', [0.354, 0.058,0.291666666666667,0.388888888888889;]) % in the middle
    monplot(1) = plot(s, empcdf(s)); hold all    
    monplot(2) = plot(s, logncdf(s, param(1), param(2)));
    monplot(3) = plot(s, abs(empcdf(s) - logncdf(s, param(1), param(2))));
    myempcdf = empcdf(s);
    monplot(4) = plot(si(1), myempcdf(1)); % this is for legend entry only. myplot(1) does dots and myplot(4) does a line. 

    myempcdf = empcdf(s);
    for i = 1:J
        mycities(i) = plot(si(i), myempcdf(i), 'markeredgecolor', mycolor(i, :)); 
    end

    set(mycities, 'marker', '.', 'markersize', 15) %, 'line', '-', 'linewidth', .01, 'color', gris)  
    set(monplot(1), 'marker', 'none', 'line', '-', 'linewidth', 1, 'color', gris)
    set(monplot(2), 'marker', 'none', 'line', '-', 'linewidth', 2, 'color', .7*noir + .3*blanc)
    set(monplot(3), 'marker', '.', 'markersize', 12, 'linewidth', 1, 'color', gris, 'markeredgecolor', gris)
    set(monplot(4), 'marker', '.', 'markersize', 15, 'line', '-', 'linewidth', .1, 'color', gris, 'markeredgecolor', rjvb(1, :))  
    
%     plot city names =====================================================
        showrank = 0;
        myrank = [1 23  27  35  69]';
        myrankstr = num2str(myrank);
        myrank = (J+1)*ones(numel(myrank), 1) - myrank; % actual s is in ascending order. Revert the rank. 
        mycityname = {'Antwerp', 'Genk', 'Mouscron', 'Beringen', 'Arlon'};
        myoffset = 8e-8;
        for i = 1:numel(myrank)
    %         mytext(i) = text(myempcdf(myrank(i)), mycdfofs(myrank(i)), strcat(sprintf('#%s\t', strtrim(myrankstr(i, :))), cellstr(mycityname(i))), 'color', mycolor(myrank(i), :));
            if showrank
                mytext(i) = text(s(myrank(i)) - myoffset, myempcdf(myrank(i)) + myoffset, ...
                sprintf('#%s %s', strtrim(myrankstr(i, :)), char(cellstr(mycityname(i)))), 'color', mycolor(myrank(i), :));
    %         mytextrank(i) = text(emppdf(myrank(i)), mycdfofs(myrank(i)), cellstr(myranknumber(i)), 'color', mycolor(myrank(i), :));
            else
                mytext(i) = text(s(myrank(i)) - myoffset, myempcdf(myrank(i)) + myoffset, ...
                cellstr(mycityname(i)), 'color', mycolor(myrank(i), :)); 
            end
            mydot(i) = plot(s(myrank(i)), myempcdf(myrank(i)), 'markerfacecolor', mycolor(myrank(i), :));
        end
%         set(mytext, 'verticalalignment', 'bottom', 'horizontalalignment', 'left')
        set(mytext, 'verticalalignment', 'bottom', 'horizontalalignment', 'right', 'rotation', 0)
    %     set(mytextrank, 'verticalalignment', 'bottom', 'horizontalalignment', 'right')
        set(mytext(5), 'horizontalalignment', 'right', 'verticalalignment', 'bottom', 'rotation', -90)
        set(mydot, 'marker', 'o', 'markersize', 8, 'markeredgecolor', gris, 'linewidth', 2)
%         =================================================================

        
        mylegend = legend(monplot([4 2 3]), 'Data', 'Estimated CDF', 'Residual');
        set(mylegend, 'location', 'east', 'box', 'off')
        xlabel('City Size s')
        ylabel('CDF')
    
        grid on
        set(gca, 'xcolor', grisp, 'ycolor', grisp, 'zcolor', grisp, 'gridlinestyle', '-', 'minorgridlinestyle', '-')
        set(gca, 'xscale', 'log', 'xlim', [s(1) s(end)])
        Caxes = copyobj(gca,gcf);
        set(Caxes, 'color', 'none', 'xcolor', noir, 'xgrid', 'off', 'ycolor', noir, 'ygrid','off')
end
savefig = 0;
if savefig
    for i = 1:2   
        hgexport(figure(i+2), filenames(i, :))
    end
end
end