function y = avglogf(s, param)

gamma   = param(1);
delta   = param(2);
knaught = param(3);
m       = param(4);

lambda = 1/m;

shat = mean(s);
J = numel(s);

const = log(gamma) + log(delta) - delta*log(shat) + log(lambda) + lambda*knaught;
variable = (delta - 1)/J*sum(log(s)) - lambda/J*sum(kofs(s, param));

y = const + variable;