function y = cdfofs(s, param)
k = sort(kofs(s, param)); 

gamma   = param(1);
delta   = param(2);
knaught = param(3);
m       = param(4);
r       = param(5);

cdf = zeros(numel(s), 1); % preallocation
for i = 1:numel(s)
    if k(i) >= knaught
        cdf(i) = 1 - (knaught + r.*m).^(1+r).*(k(i) + r.*m).^(-1-r);
    else
%         fprintf('k_0 is binding.\n')
        cdf(i) = 0;
    end
end
y = cdf; 