function y = pdfofs(s, param)
k = sort(kofs(s, param)); 

gamma   = param(1);
delta   = param(2);
knaught = param(3);
m       = param(4);
r       = param(5);
    
term1 = delta*k./s;
gofk = (r+1)*(k+r*m).^(-r-2).*(knaught + r*m).^(r+1);  

y = term1.*gofk;