function y = plotjrofs10_intro(s)
% myplotjrofs2: on 5/28/14. For some reason myplot fucks things up with
% plot. There is some unknown line added to a pdf and I don't know where it
% came from. It disappears if I switch myplot(i) to monplot(i). I really
% don't know why but I'm using mosnplot here. 
% plotjrofs3: on 5/31/14. Coloring the cities according to their size.
% plotjrofs4: removing the gray circle perimeter for better visibility. 
% plotjrofs5: switching to pdfofs9 from pdfofs4 for log-scaled s for better
% pdf representation. 
% plotjrofs8 on 6/25/14: switching emppdf (ksdensity) and estpdf alignment
% method (from aligning maximum hight to min RSS between emppdf and
% estpdf). Note that analytical pdfofs_smooth2.m in jrbelgium or jrma does not work
% here and you need to use empirically defined pdfofs9.m here to have
% successful pdf presentation

% plotjrofs10_intro.m on 7/11/14: expanding the figure output size to see
% secondary axis on log scale (figure(3)). 

close all
color
s = sort(s); % sort s so that pdf and cdf plots won't go back and forth. 
% Also, remove 0 from s so you can take a log. 

% for i = 1:2
% %     myt(i, :) = num2str(i, '%d');
%     filenames(i, :) = strcat('jrofs_mse', myt(i, :));
% end
filenames(1, :) = 'cs_pdf';
filenames(2, :) = 'cs_cdf';
filenames(3, :) = 'cs_lin';

showfigure = [0 0 1];

J = numel(s);

if showfigure(1) %1111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111
    figure(3)
    set(gcf,'defaultaxesfontsize', 13, 'DefaultAxesLineWidth', 1, 'DefaultAxesColorOrder', [gris; rjvb(end, :); .7*noir+.3*blanc], ...
        'defaultlinelinewidth', 2, ...
        'defaultlinemarkersize', 20, ...
        'defaultlinemarker', '.', ...
        'defaulttextfontsize', 13, ...
        'defaultaxesnextplot', 'add', ...
        'units', 'normalized', 'position',  [0.0500    0.0400    1.6*0.2917    1.6*0.3889])
                
%         find ks density (equally spaced s) ===========
%             ks density estimation works for standardized data. Since log(s)
%             follows Gaussian, I'll take log of s first ...
            [emppdf2, si2] = ksdensity(log(s));
%             ... and then convert it back to linear scale 
            si2 = exp(si2);
%         =================================
%     mydeflator = deflator(ksdensity(log(s), log(s)), pdfofs9(s, param));
%     monplot(1) = plot(si2, emppdf2/max(emppdf2)*max(pdfofs9(s, param))); hold all  % draw a line only 
    monplot(1) = plot(si2, emppdf2); hold all
    
    
%         find ks density (datapoint s) ===========
%             ks density estimation works for standardized data. Since log(s)
%             follows Gaussian, I'll take log of s first ...
            [emppdf, si] = ksdensity(log(s), log(s));  % second log(s) to mark s at which ksdensity is evaluated
%             ... and then convert it back to linear scale 
            si = exp(si);
%         =================================
%     monplot(1) = plot(si, emppdf/max(emppdf)*max(pdfofs4(s, param))); hold all
                % rescale data above so it will match the estimated pdf
                % (pdfofs). These two are evaluated at two differenent sets
                % of s's. Plus, estimated pdf below is the derivative whereas
                % ksdensity above is produced from s. There is no guarantee that
                % they will match up in scale.  
                myemppdf = emppdf;
%       Assign color and markersize according to the city size =============
        mycolor = zeros(J, 3); % preallocation
        mymarkersize = zeros(J, 1); % preallocation
        maxmarkersize = 80;
        
        for i = 1:J
            if s(i) == 1
                mycolor(i, :) = rjvb(1, :);
                mymarkersize(i) = 1;
            else
                mycolor(i, :) = rjvb(ceil((s(i) - min(s))/(max(s) - min(s))*255), :);
                mymarkersize(i) = ceil(sqrt((s(i) - min(s))/(max(s) - min(s)))*maxmarkersize); % you need to take sqrt cuz marker size is based on radius but not on the area size. 
            end  
        end
%         =====================================================
    for i = 1:J
        mycities(i) = plot(si(i), myemppdf(i), 'color', mycolor(i, :), 'markerfacecolor', mycolor(i, :), 'markersize', mymarkersize(i)); 
    end
    
    set(mycities, 'marker', 'o') %, 'line', '-', 'linewidth', .1, 'color', gris)
    monplot(2) = plot(si(1), myemppdf(1)); % this is for legend entry only. myplot(1) does dots and myplot(4) does a line. 
% %     monplot(3) = plot(si2, pdfofs_smooth(si2, param));    
%     monplot(3) = plot(s, pdfofs9(s, param)/mydeflator);

    set(monplot(1), 'marker', 'none', 'line', '-', 'linewidth', 1, 'color', gris)
    set(monplot(2), 'marker', '.', 'markersize', 15, 'line', '-', 'linewidth', .1, 'color', gris, 'markeredgecolor', rjvb(1, :))  
%     set(monplot(3), 'marker', 'none', 'linewidth', 2, 'color', gris)
    
%     plot city names =====================================================
        showrank = 1;
        myrank = [1 2 206 949 4205 12202 12677 25357]';
        myrankstr = num2str(myrank);
        myrank = (J+1)*ones(numel(myrank), 1) - myrank; % actual s is in ascending order. Revert the rank. 
        mycityname = {'New York', 'Los Angeles', 'Beaumont, TX', 'University City, MO', 'Hillsboro, TX', 'Sutton, NE', 'Harristown, IL', 'New Amsterdam, IN'};
        myoffset = 2e-3;
        for i = 1:numel(myrank)
    %         mytext(i) = text(myempcdf(myrank(i)), mycdfofs(myrank(i)), strcat(sprintf('#%s\t', strtrim(myrankstr(i, :))), cellstr(mycityname(i))), 'color', mycolor(myrank(i), :));
            if showrank
                if i == 6 || i == 7
                    mytext(i) = text(s(myrank(i)) - myoffset, myemppdf(myrank(i)) - myoffset, ...
                    sprintf('#%s %s', strtrim(myrankstr(i, :)), char(cellstr(mycityname(i)))), 'color', mycolor(myrank(i), :));
                elseif i == 1
                    mytext(i) = text(s(myrank(i)), myemppdf(myrank(i)) + .03, ...
                    sprintf('#%s %s', strtrim(myrankstr(i, :)), char(cellstr(mycityname(i)))), 'color', mycolor(myrank(i), :));
                elseif i == 2 
                    mytext(i) = text(s(myrank(i)), myemppdf(myrank(i)) + .02, ...
                    sprintf('#%s %s', strtrim(myrankstr(i, :)), char(cellstr(mycityname(i)))), 'color', mycolor(myrank(i), :));
                else
                    mytext(i) = text(s(myrank(i)) - myoffset, myemppdf(myrank(i)) + myoffset, ...
                    sprintf('#%s %s', strtrim(myrankstr(i, :)), char(cellstr(mycityname(i)))), 'color', mycolor(myrank(i), :));
                end
    %         mytextrank(i) = text(emppdf(myrank(i)), mycdfofs(myrank(i)), cellstr(myranknumber(i)), 'color', mycolor(myrank(i), :));
            else
                if i == 6
                    mytext(i) = text(s(myrank(i)) - myoffset, myemppdf(myrank(i)) - 5*myoffset, ...
                    cellstr(mycityname(i)), 'color', mycolor(myrank(i), :)); 
                else
                    mytext(i) = text(s(myrank(i)) - myoffset, myemppdf(myrank(i)) + myoffset, ...
                    cellstr(mycityname(i)), 'color', mycolor(myrank(i), :)); 
                end
            end
            mydot(i) = plot(s(myrank(i)), myemppdf(myrank(i)), 'color', gris, 'markerfacecolor', mycolor(myrank(i), :), 'markersize', mymarkersize(myrank(i)));
        end
%         set(mytext, 'verticalalignment', 'bottom', 'horizontalalignment', 'left')
        set(mytext, 'verticalalignment', 'bottom', 'horizontalalignment', 'right', 'rotation', -90)
        set(mytext([1 2]), 'verticalalignment', 'middle')
        set(mytext(6), 'horizontalalignment', 'left', 'verticalalignment', 'top')
        set(mytext(7), 'horizontalalignment', 'left', 'verticalalignment', 'bottom')
%         set(mytext(6), 'horizontalalignment', 'right', 'rotation', 0)
    %     set(mytextrank, 'verticalalignment', 'bottom', 'horizontalalignment', 'right')
%         for i = 1:numel(myrank)
            set(mydot, 'marker', 'o', 'markeredgecolor', gris, 'linewidth', 2) % the linewidth of 2 will bury these points in the graph. use 5. 
%         end
%         set(mydot([1 2]), 'linewidth', 2)
%         =================================================================
    
%     mylegend = legend([monplot(2) monplot(3)], 'Data', 'Estimated PDF');
%     set(mylegend, 'location', 'northwest', 'box', 'off')
    xlabel('City Size s')
    ylabel('PDF')
    
        grid on
        set(gca, 'xcolor', grisp, 'ycolor', grisp, 'zcolor', grisp, 'gridlinestyle', '-', 'minorgridlinestyle', '-')
        set(gca, 'xlim', [s(1)-1e-2 s(end)])
        set(gca, 'xscale', 'log')
        set(gca, 'xaxislocation', 'top')
        set(gca, 'yticklabel', sprintf('%01.2f|', 0:.05:.25))
        Caxes = copyobj(gca,gcf);
        set(Caxes, 'color', 'none', 'xcolor', noir, 'xgrid', 'off', 'ycolor', noir, 'ygrid','off')
end









if showfigure(2) %2222222222222222222222222222222222222222222222222222222222222222222222222222222222222222222222222222222222222222222222222222222222222222222222222222222222222222222222222222222222222222222222222222222
    figure(4)
    set(gcf,'defaultaxesfontsize', 13, 'DefaultAxesLineWidth', 1, 'DefaultAxesColorOrder', [gris; vert; bfonce], ...
        'defaultlinelinewidth', 2, ...
        'defaultlinemarkersize', 10, ...
        'defaultlinemarker', '.', ...
        'defaulttextfontsize', 13, ...
        'defaultaxesnextplot', 'add', ...        
        'units', 'normalized', 'position', [0.65    0.04    0.291666666666667,0.388888888888889])
%         'units', 'normalized', 'position', [0.65,0.515,0.291666666666667,0.388888888888889;]) % to the right of fig(1)
%         'units', 'normalized', 'position', [0.354, 0.058,0.291666666666667,0.388888888888889;]) % in the middle
    monplot(1) = plot(s, empcdf(s)); hold all    
%     monplot(2) = plot(s, cdfofs(s, param));
%     monplot(3) = plot(s, abs(empcdf(s) - cdfofs(s, param)));
    myempcdf = empcdf(s);
    monplot(2) = plot(si(1), myempcdf(1)); % this is for legend entry only. myplot(1) does dots and myplot(4) does a line. 

    myempcdf = empcdf(s);
    for i = 1:J
        mycities(i) = plot(si(i), myempcdf(i), 'markeredgecolor', mycolor(i, :)); 
    end

    set(mycities, 'marker', '.', 'markersize', 15) %, 'line', '-', 'linewidth', .01, 'color', gris)  
    set(monplot(1), 'marker', 'none', 'line', '-', 'linewidth', 1, 'color', gris)
%     set(monplot(2), 'marker', 'none', 'line', '-', 'linewidth', 2, 'color', gris)
%     set(monplot(3), 'marker', '.', 'markersize', 12, 'linewidth', 1, 'color', gris, 'markeredgecolor', gris)
    set(monplot(2), 'marker', '.', 'markersize', 15, 'line', '-', 'linewidth', .1, 'color', gris, 'markeredgecolor', rjvb(1, :))  
    
%     plot city names =====================================================
        showrank = 0;
        myrank = [1 206 949 4205 12202 12677 25357]';
        myrankstr = num2str(myrank);
        myrank = (J+1)*ones(numel(myrank), 1) - myrank; % actual s is in ascending order. Revert the rank. 
        mycityname = {'New York', 'Beaumont, TX', 'University City, MO', 'Hillsboro, TX', 'Sutton, NE', 'Harristown, IL', 'New Amsterdam, IN'};
        myoffset = 5e-3; 
        myhoroffset = 1e-3;
        for i = 1:numel(myrank)
    %         mytext(i) = text(myempcdf(myrank(i)), mycdfofs(myrank(i)), strcat(sprintf('#%s\t', strtrim(myrankstr(i, :))), cellstr(mycityname(i))), 'color', mycolor(myrank(i), :));
            if showrank
                mytext(i) = text(s(myrank(i)) - myhoroffset, myempcdf(myrank(i)) + myoffset, ...
                sprintf('#%s %s', strtrim(myrankstr(i, :)), char(cellstr(mycityname(i)))), 'color', mycolor(myrank(i), :));
    %         mytextrank(i) = text(emppdf(myrank(i)), mycdfofs(myrank(i)), cellstr(myranknumber(i)), 'color', mycolor(myrank(i), :));
            else
                mytext(i) = text(s(myrank(i)) - myhoroffset, myempcdf(myrank(i)) + myoffset, ...
                cellstr(mycityname(i)), 'color', mycolor(myrank(i), :)); 
            end
            mydot(i) = plot(s(myrank(i)), myempcdf(myrank(i)), 'markerfacecolor', mycolor(myrank(i), :), 'markersize', mymarkersize(myrank(i)));
        end
%         set(mytext, 'verticalalignment', 'bottom', 'horizontalalignment', 'left')
        set(mytext, 'verticalalignment', 'bottom', 'horizontalalignment', 'right', 'rotation', 0)
        set(mytext([3 6]), 'verticalalignment', 'top', 'horizontalalignment', 'left')
    %     set(mytextrank, 'verticalalignment', 'bottom', 'horizontalalignment', 'right')
        set(mytext(7), 'horizontalalignment', 'right', 'verticalalignment', 'bottom', 'rotation', -90)
        set(mydot, 'marker', 'o', 'markersize', 8, 'markeredgecolor', gris, 'linewidth', 2)
%         =================================================================

        
%         mylegend = legend(monplot([4 2 3]), 'Data', 'Estimated CDF', 'Residual');
%         set(mylegend, 'location', 'southeast', 'box', 'off')
        xlabel('City Size s')
        ylabel('CDF')
    
        grid on
        set(gca, 'xcolor', grisp, 'ycolor', grisp, 'zcolor', grisp, 'gridlinestyle', '-', 'minorgridlinestyle', '-')
        set(gca, 'xscale', 'log', 'xlim', [s(1) s(end)])
        Caxes = copyobj(gca,gcf);
        set(Caxes, 'color', 'none', 'xcolor', noir, 'xgrid', 'off', 'ycolor', noir, 'ygrid','off')
end





if showfigure(3) %333333333333333333333333333333333333333333333333333333333333333333333333333333333333333333333333333333333333333333333333333333333333333333333333333333333333333333333333333333333333333333333333333333333333
    figure(5)
    set(gcf,'defaultaxesfontsize', 13, 'DefaultAxesLineWidth', 1, 'DefaultAxesColorOrder', [gris; rjvb(end, :); .7*noir+.3*blanc], ...
        'defaultlinelinewidth', 2, ...
        'defaultlinemarkersize', 20, ...
        'defaultlinemarker', '.', ...
        'defaulttextfontsize', 13, ...
        'defaultaxesnextplot', 'add', ...
        'units', 'normalized', 'position',  [0.3517    0.0400    1.6*0.2917    1.6*0.3889])
                
%         find ks density (equally spaced s) ===========
%             ks density estimation works for standardized data. Since log(s)
%             follows Gaussian, I'll take log of s first ...
            [emppdf2, si2] = ksdensity(log(s));
%             ... and then convert it back to linear scale 
            si2 = exp(si2);
%         =================================
%     mydeflator = deflator(ksdensity(log(s), log(s)), pdfofs9(s, param));
%     monplot(1) = plot(si2, emppdf2/max(emppdf2)*max(pdfofs9(s, param))); hold all  % draw a line only 
    monplot(1) = plot(si2, emppdf2); hold all
    
    
%         find ks density (datapoint s) ===========
%             ks density estimation works for standardized data. Since log(s)
%             follows Gaussian, I'll take log of s first ...
            [emppdf, si] = ksdensity(log(s), log(s));  % second log(s) to mark s at which ksdensity is evaluated
%             ... and then convert it back to linear scale 
            si = exp(si);
%         =================================
%     monplot(1) = plot(si, emppdf/max(emppdf)*max(pdfofs4(s, param))); hold all
                % rescale data above so it will match the estimated pdf
                % (pdfofs). These two are evaluated at two differenent sets
                % of s's. Plus, estimated pdf below is the derivative whereas
                % ksdensity above is produced from s. There is no guarantee that
                % they will match up in scale.  
                myemppdf = emppdf;
%       Assign color and markersize according to the city size =============
        mycolor = zeros(J, 3); % preallocation
        mymarkersize = zeros(J, 1); % preallocation
        maxmarkersize = 80;
        
        for i = 1:J
            if s(i) == 1
                mycolor(i, :) = rjvb(1, :);
                mymarkersize(i) = 1;
            else
                mycolor(i, :) = rjvb(ceil((s(i) - min(s))/(max(s) - min(s))*255), :);
                mymarkersize(i) = ceil(sqrt((s(i) - min(s))/(max(s) - min(s)))*maxmarkersize); % you need to take sqrt cuz marker size is based on radius but not on the area size. 
            end  
        end
%         =====================================================
    for i = 1:J
        mycities(i) = plot(si(i), myemppdf(i), 'color', mycolor(i, :), 'markerfacecolor', mycolor(i, :), 'markersize', mymarkersize(i)); 
    end
    monplot(2) = plot(si(1), myemppdf(1)); % this is for legend entry only. myplot(1) does dots and myplot(4) does a line. 
% %     monplot(3) = plot(si2, pdfofs_smooth(si2, param));    
%     monplot(3) = plot(s, pdfofs9(s, param)/mydeflator);

    set(mycities, 'marker', 'o') %, 'line', '-', 'linewidth', .1, 'color', gris)
    set(monplot(1), 'marker', 'none', 'line', '-', 'linewidth', 1, 'color', gris)
    set(monplot(2), 'marker', '.', 'markersize', 15, 'line', '-', 'linewidth', .1, 'color', gris, 'markeredgecolor', rjvb(1, :))  
%     set(monplot(3), 'marker', 'none', 'linewidth', 2, 'color', gris)
    
%     plot city names =====================================================
        showrank = 1;
        myrank = [1 2 206 949 4205 12202 12677 25357]';
        myrankstr = num2str(myrank);
        myrank = (J+1)*ones(numel(myrank), 1) - myrank; % actual s is in ascending order. Revert the rank. 
        mycityname = {'New York      ', 'Los Angeles  ', 'Beaumont, TX', 'University City, MO', 'Hillsboro, TX', 'Sutton, NE', 'Harristown, IL', 'New Amsterdam, IN'};
        myoffset = 2e-3;
        for i = 1:numel(myrank)
    %         mytext(i) = text(myempcdf(myrank(i)), mycdfofs(myrank(i)), strcat(sprintf('#%s\t', strtrim(myrankstr(i, :))), cellstr(mycityname(i))), 'color', mycolor(myrank(i), :));
            if showrank
                if i == 6 || i == 7
                    mytext(i) = text(s(myrank(i)) - myoffset, myemppdf(myrank(i)) - myoffset, ...
                    sprintf('#%s %s', strtrim(myrankstr(i, :)), char(cellstr(mycityname(i)))), 'color', mycolor(myrank(i), :));
                elseif i == 1
                    mytext(i) = text(s(myrank(i)), myemppdf(myrank(i)) + .03, ...
                    sprintf('#%s %s', strtrim(myrankstr(i, :)), char(cellstr(mycityname(i)))), 'color', mycolor(myrank(i), :));
                elseif i == 2 
                    mytext(i) = text(s(myrank(i)), myemppdf(myrank(i)) + .02, ...
                    sprintf('#%s %s', strtrim(myrankstr(i, :)), char(cellstr(mycityname(i)))), 'color', mycolor(myrank(i), :));
                else
                    mytext(i) = text(s(myrank(i)) - myoffset, myemppdf(myrank(i)) + myoffset, ...
                    sprintf('#%s %s', strtrim(myrankstr(i, :)), char(cellstr(mycityname(i)))), 'color', mycolor(myrank(i), :));
                end
    %         mytextrank(i) = text(emppdf(myrank(i)), mycdfofs(myrank(i)), cellstr(myranknumber(i)), 'color', mycolor(myrank(i), :));
            else
                if i == 6
                    mytext(i) = text(s(myrank(i)) - myoffset, myemppdf(myrank(i)) - 5*myoffset, ...
                    cellstr(mycityname(i)), 'color', mycolor(myrank(i), :)); 
                else
                    mytext(i) = text(s(myrank(i)) - myoffset, myemppdf(myrank(i)) + myoffset, ...
                    cellstr(mycityname(i)), 'color', mycolor(myrank(i), :)); 
                end
            end
            mydot(i) = plot(s(myrank(i)), myemppdf(myrank(i)), 'color', gris, 'markerfacecolor', mycolor(myrank(i), :), 'markersize', mymarkersize(myrank(i)));
        end
%         set(mytext, 'verticalalignment', 'bottom', 'horizontalalignment', 'left')
        set(mytext, 'verticalalignment', 'bottom', 'horizontalalignment', 'right', 'rotation', -90)
        set(mytext([1 2]), 'verticalalignment', 'middle')
%         set(mytext(6), 'horizontalalignment', 'left', 'verticalalignment', 'middle')
%         set(mytext(5), 'horizontalalignment', 'left', 'rotation', 0)
    %     set(mytextrank, 'verticalalignment', 'bottom', 'horizontalalignment', 'right')
    
%         for i = 1:numel(myrank)
            set(mydot, 'marker', 'o', 'markeredgecolor', gris, 'linewidth', 2)
%         end
%         set(mydot([1 2]), 'linewidth', 2)

%         =================================================================
    
%     mylegend = legend([monplot(2) monplot(3)], 'Data', 'Estimated PDF');
%     set(mylegend, 'location', 'northwest', 'box', 'off')
    xlabel('City Size s')
    ylabel('PDF')
    
        grid on
        set(gca, 'xcolor', grisp, 'ycolor', grisp, 'zcolor', grisp, 'gridlinestyle', '-', 'minorgridlinestyle', '-')
        set(gca, 'xlim', [s(1)-1e-2 s(end)])
        set(gca, 'xscale', 'linear', ...
            'xaxislocation', 'top')
        set(gca, 'yticklabel', sprintf('%01.2f|', 0:.05:.25))
        Caxes = copyobj(gca,gcf);
        set(Caxes, 'color', 'none', 'xcolor', noir, 'xgrid', 'off', 'ycolor', noir, 'ygrid','off')
end

savefig = 0;
if savefig
    for i = 1:3
        hgexport(figure(i+2), filenames(i, :))
    end
end
end