function y = pdfofs5(s, param)
% pdfofs.m: pdf as a derivative of cdf
% pdfofs2.m: pdf as a differential of cdf
% pdfofs4.m: on 5/28/14. I forgot to devide cdf(2)-cdf(1) by s(2)-s(1) in
% pdfofs3 and pdfofs2. 

% actually pdfofs4 and pdfofs returns almost the same results. Try running
% plot(s, pdfofs(s, estparam), s, pdfofs4(s, estparam))
% set(gca, 'xscale', 'log')
% They match except for s_1, which I replaced with 0 here. 
% I guess I'll just use pdfofs then. It's kinda hard to see the
% relationship between PDF and CDF from plot but I guess it's just how they
% are. 

% pdfofs5.m: 5/29/14. for a certain range of parameters, pdfofs or pdfofs4 plots
% something that is not really in tune with pdf. Probably because of log
% scaling. Here I will use log scaled s to compute the slope in the effort
% to allign the pdf with the cdf. 

J = numel(s);

cdf = cdfofs(s, param);         % [cdf(1)  cdf(2)  ... cdf(J)]'
prev = [0; cdf(1:end-1)];       % [0       cdf(1)  ... cdf(J-1)]'

denom = s(2:J) - s(1:J-1);

temp = (cdf(2:J)-prev(2:J))./denom;  % [(cdf(2)-cdf(1))/(s_2 - s_1)   ... (cdf(J)-cdf(J-1))/(s_J - s_{J-1})]'

y = [0; temp]; % I got to fill 0 for pdf(s_1) cuz I can't define it when there is no s_0. 


