function y = scaler(myscaler, emppdf, estpdf)

rssorabs = 1; % pick your fitting method. 
% set this equal to one if you're minimizing the sum of squared residuals and
% zero if you're minimizing the sum of absolute residuals. Just pick
% whichever fits the empirical distribution better. 
% 0 for mle, 1 for minks for belgium

if rssorabs
    y = sum((emppdf*myscaler - estpdf).^2);
else
    y = sum(abs(emppdf*myscaler - estpdf));
end
