function y = pdfofs_galton_smooth(s, param)
% s can be anything for pdfofs_smooth (as opposed to pdfofs, the functional
% form of which depends on s itself). pdfofs_smooth just returns an analytical
% function. 5/29/14. 

% Do not use mean(log(s)) as mu as s can be anything. 
load estparam_galton.mat

y = lognpdf(s, estparam_galton(1), estparam_galton(2));
