function y = pdfofs_gev(s, param)

mu      = param(1);
sigma   = param(2);
xi      = param(3);
gamma   = param(4);
kappa   = param(5);

x = (s/kappa).^((1 - gamma)/gamma);
z = (x - mu)/sigma;

term1 = (1-gamma)/gamma*kappa^((gamma - 1)/gamma)*s.^((1 - 2*gamma)/gamma)/sigma;
term2 = (1 + xi*z).^(-1/xi - 1);
term3 = exp( -(1 + xi*z).^(-1/xi));
y = term1.*term2.*term3;