function y = pdfofs_gev_smooth(s, param)
% s can be anything for pdfofs_smooth (as opposed to pdfofs, the functional
% form of which depends on s itself). pdfofs_smooth just returns an analytical
% function. 5/29/14. 

% Do not compute param within this function because s can be anything (not
% necessarily data points but some equally spaced s for plotting purposes).
% Rather, load estparam_gev.mat from outside of the function as follows:
load estparam_gev.mat

y = pdfofs_gev(s, estparam_gev);
