function y = scaler2(myscaler, emppdf, estpdf)
% scaler2.m on 7/6/14: instead of inflating emppdf, inflating estpdf.
% estpdf is much smaller than emppdf and this smallness may be causing some
% problem. 

rssorabs = 0; % pick your fitting method. 
% set this equal to one if you're minimizing the sum of squared residuals and
% zero if you're minimizing the sum of absolute residuals. Just pick
% whichever fits the empirical distribution better. 
% 0 for mle, 1 for minks for belgium.
% 2 for maximum distance

if rssorabs
    y = sum((emppdf - estpdf*myscaler).^2);
elseif rssorabs == 0
    y = sum(abs(emppdf - estpdf*myscaler));
else
    y = max(abs(emppdf - estpdf*myscaler));
end
