function y = scaler_gev(myscaler, emppdf, estpdf)

rssorabs = 0; % pick your fitting method. 
% set this equal to one if you're minimizing the sum of squared residuals and
% zero if you're minimizing the sum of absolute residuals. Just pick
% whichever fits the empirical distribution better. 
% 0 for mle, 1 for minks for belgium.
% 2 for maximum distance
% 0 worked for galton. 

if rssorabs
    y = sum((emppdf*myscaler - estpdf).^2);
elseif rssorabs == 0
    y = sum(abs(emppdf*myscaler - estpdf));
else
    y = max(abs(emppdf*myscaler - estpdf));
end
