function y = showstats(s, param)

fprintf('========================\n')
theta = char('gamma', 'delta', 'k_0', 'm', 'r', 'kappa', 'tau', 'rand to net');
for i = 1:size(theta, 1)-1
    fprintf('& %s', theta(i, :))
end
    fprintf('& %s\n', theta(end, :))

fprintf('%s', num2str([param kappa(s, param) tau(s, param)], '& %05.4g\t'))

randnetvalue = randnet(s, param);
fprintf('\t%s', num2str(randnetvalue(1), '& %4.3g to '))
fprintf(' %s\n', num2str(randnetvalue(2), '%4.3g'))


fprintf('-------------------------\n')


stats = char('J', '<logLH>', 'KS', '<logstep>', 'geo/ari', 'BIC', 'AIC');
for i = 1:size(stats, 1)-1
    fprintf('& %s\t\t', stats(i, :))
end
    fprintf('& %s\n', stats(end, :))
fprintf('& %d\t\t\t', numel(s))    
fprintf('%s', num2str(mystats(s, param), '& %05.4g\t'))

fprintf('\t\t\t\t%s', num2str(exp(geogap(s, param)), '& %05.4g/'))
fprintf('%s\t', num2str(1/numel(s), '%05.4g'))

fprintf('%s', num2str(abic(s, param), '& %05.4g\t'))


fprintf('\n========================\n')