function y = pdfofs_exp_smooth(si, param)
% do not use input s as data s here. input s may not be data s. 
load s.dat 

% k = sort(kofs(si, param)); % can't use k due to conflict with a function named k. using myk instead. 
% kofs is shared between jr ER/BA and jr BA. 
% \uparrow you can't use kofs because it compute shat from the input si,
% which may be diffrerent from s. \downarrow solution

% compute k of s manually inside this file =============
gamma = param(1);
delta = param(2);
% knaught = param(3); 
%     m = param(4);
%     r = param(5);
shat = mean(s);

k = gamma.*(si./shat).^delta;
% ========================================================

gamma   = param(1);
delta   = param(2);
knaught = param(3);
m       = param(4);

lambda = 1/m;
% do not use mean(s). s can be anything in this function. 
% shat = mean(s); % \leftarrow it's already defined above. 

J = numel(si);

pdf = zeros(J, 1); % preallcation

for i = 1:J
    if k(i) < knaught
        pdf(i) = 0;
    else
        pdf(i) = gamma*delta*shat^(-delta)*si(i).^(delta - 1)*lambda.*exp(-lambda*(k(i)-knaught));
    end
end

y = pdf;