function y = pdfofs_smooth(s, param)
% s can be anything for pdfofs_smooth (as opposed to pdfofs, the functional
% form of which depends on s itself). pdfofs_smooth just returns an analytical
% function. 5/29/14. 

gamma   = param(1);
delta   = param(2);
knaught = param(3);
m       = param(4);
r       = param(5);

shat = 6.2960e+04; % do not set shat = mean(s) here. Input s here can be anything. 

y = (knaught + r*m)^(r+1)*(r+1)*gamma*shat^(-delta)*delta*s.^(delta-1).*(gamma*s.^delta*shat^(-delta) + r*m).^(-r-2);

    
