function y = abic(s, param)

gamma   = param(1);
delta   = param(2);
knaught = param(3);
m       = param(4);
r       = param(5);

shat = mean(s);
J = numel(s);

avgloglh = log(delta) + log(gamma) - delta*log(shat) + log(r+1) + ...
    (r+1)*log(knaught + r*m) + ...
    (delta - 1)*mean(log(s)) + ...
    (-r-2)*sum(log(gamma*s.^delta * shat^(-delta) + r*m))/J;

bic = -2*J*avgloglh + numel(param)*log(J);
y(1) = bic;

aic = -2*J*avgloglh + 2*numel(param);
y(2) = aic;