function y = pdfofk(s, param)
myk = sort(kofs(s, param)); % can't use k due to conflict with a function named k. using myk instead. 

gamma   = param(1);
delta   = param(2);
knaught = param(3);
m       = param(4);
r       = param(5);
    
y = delta*myk.*s.^(-1).*(r+1).*(myk + r*m).^(-r-2)*(knaught + r*m)^(r+1);