function y = cdfofs_gev(s, param)

mu      = param(1);
sigma   = param(2);
xi      = param(3);
gamma   = param(4);
kappa   = param(5);

x = (s/kappa).^((1 - gamma)/gamma);
z = (x - mu)/sigma;

y = exp( -(1 + xi*z).^(-1/xi));
