function y = showstats_gev(s, param)

fprintf('========================\n')
theta = char('mu', 'sigma', 'xi', 'gamma', 'kappa');
for i = 1:size(theta, 1)-1
    fprintf('& %s', theta(i, :))
end
    fprintf('& %s\n', theta(end, :))

fprintf('%05.4g &', param)
fprintf('\n-------------------------\n')

stats = char('J', '<logLH>', 'KS', '<logstep>', 'geo/ari', 'BIC', 'AIC');
for i = 1:size(stats, 1)-1
    fprintf('& %s\t\t', stats(i, :))
end
    fprintf('& %s\n', stats(end, :))
fprintf('& %d\t\t\t', numel(s))    
fprintf('%s', num2str(mystats_gev(s, param), '& %05.4g\t'))

fprintf('\t\t\t\t%s', num2str(exp(geogap_gev(s, param)), '& %05.4g/'))
fprintf('%s\t', num2str(1/numel(s), '%05.4g'))

fprintf('%s', num2str(abic_gev(s, param), '& %05.4g\t'))


fprintf('\n========================\n')